"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _color = _interopRequireDefault(require("color"));

var _colourNames = _interopRequireDefault(require("./lib/colourNames"));

var _toShorthand = _interopRequireDefault(require("./lib/toShorthand"));

var ctype = _interopRequireWildcard(require("./lib/colourType"));

var _stripWhitespace = _interopRequireDefault(require("./lib/stripWhitespace"));

var _trimLeadingZero = _interopRequireDefault(require("./lib/trimLeadingZero"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var filterColor = function filterColor(callback) {
  return Object.keys(_colourNames["default"]).filter(callback);
};

var shorter = function shorter(a, b) {
  return (a && a.length < b.length ? a : b).toLowerCase();
};

var _default = function _default(colour) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  if (ctype.isRGBorHSL(colour)) {
    var c; // Pass through invalid rgb/hsl functions

    try {
      c = (0, _color["default"])(colour);
    } catch (err) {
      return colour;
    }

    if (c.alpha() === 1) {
      // At full alpha, just use hex
      colour = c.hexString();
    } else {
      var rgb = c.rgb();

      if (!opts.legacy && !rgb.r && !rgb.g && !rgb.b && !rgb.a) {
        return 'transparent';
      }

      var hsla = c.hslaString();
      var rgba = c.rgbString();
      return (0, _trimLeadingZero["default"])((0, _stripWhitespace["default"])(hsla.length < rgba.length ? hsla : rgba));
    }
  }

  if (ctype.isHex(colour)) {
    colour = (0, _toShorthand["default"])(colour.toLowerCase());
    var keyword = filterColor(function (key) {
      return _colourNames["default"][key] === colour;
    })[0];
    return shorter(keyword, colour);
  } else if (ctype.isKeyword(colour)) {
    var hex = _colourNames["default"][filterColor(function (k) {
      return k === colour.toLowerCase();
    })[0]];

    return shorter(hex, colour);
  } // Possibly malformed, just pass through


  return colour;
};

exports["default"] = _default;
module.exports = exports.default;