"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isKeyword = exports.isRGBorHSL = exports.isHex = void 0;

var _has = _interopRequireDefault(require("has"));

var _colourNames = _interopRequireDefault(require("./colourNames"));

var _toLonghand = _interopRequireDefault(require("./toLonghand"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var isHex = function isHex(colour) {
  if (colour[0] === '#') {
    var c = (0, _toLonghand["default"])(colour).substring(1);
    return c.length === 6 && !isNaN(parseInt(c, 16));
  }

  return false;
};

exports.isHex = isHex;

var isRGBorHSL = function isRGBorHSL(colour) {
  return /^(rgb|hsl)a?\(.*?\)/.test(colour);
};

exports.isRGBorHSL = isRGBorHSL;

var isKeyword = function isKeyword(colour) {
  return (0, _has["default"])(_colourNames["default"], colour.toLowerCase());
};

exports.isKeyword = isKeyword;